/*
 * Copyright 2020 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package fr.gaellalire.rmiregistry;

import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;
import java.util.concurrent.Callable;

public class RMIRegistryLauncher implements Callable<Void> {

    @Override
    public Void call() throws Exception {

        Registry registry = LocateRegistry.createRegistry(1099);
        try {
            synchronized (this) {
                try {
                    wait();
                } catch (InterruptedException e) {
                    // exiting
                }
            }
        } finally {
            UnicastRemoteObject.unexportObject(registry, true);
        }
        return null;
    }

}
